package com.demo.controller;

import org.springframework.web.bind.annotation.RestController;

import com.demo.service.CompareTwoTables;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;



@RestController
@CrossOrigin
public class VerifyMigrationController {
	@Autowired
	CompareTwoTables service ;
	
	
	@RequestMapping("/tables")
	@ResponseBody
	public Map<String,List<String>> getTables() {
		
		Map<String,List<String>> tables = new HashMap<String,List<String>>();
		
		tables.put("source",service.getSourceTables());
		tables.put("destination",service.getDesticationTables());
		
		
		
		return tables;
	}
	
	
	@RequestMapping("/columns")
	@ResponseBody
	public Map<String,List<String>> getColumns(@RequestParam("srcTable") String srcTable,@RequestParam("destTable") String destTable,@RequestParam("sqlStatus") String sqlStatus) {
		
		System.out.println(srcTable);
		Map<String,List<String>> tableColumns = new HashMap<String,List<String>>();
		
		if(sqlStatus.equals("sqlTrue")) {
			tableColumns.put("source",service.getSourceColumnsBySql(srcTable));
			tableColumns.put("destination",service.getDestinationColumns(destTable));
			
			tableColumns.put("srcKeys",new LinkedList<>());
			tableColumns.put("destKeys",service.getDestinationTablesKey(destTable));
		}else {
		
		tableColumns.put("source",service.getSourceColumns(srcTable));
		tableColumns.put("destination",service.getDestinationColumns(destTable));
		
		tableColumns.put("srcKeys",service.getSourceTablesKey(srcTable));
		tableColumns.put("destKeys",service.getDestinationTablesKey(destTable));
		}
		
		
		return tableColumns;
	}

}
