package com.demo.service;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import com.demo.DataSourceDbUtil;

@Repository
public class CompareTwoTables {

	@Autowired
	private DataSourceDbUtil dataSource;

	public Map<String, Object> getCompareTwoTables(String srcTable, String destTable, String srcColumn,
			String destColumn, String srcKey, String destKey, int currentPageNo) throws Exception {

		Map<String, Object> map = new HashMap<>();

		// step3 create the statement object
		Long begin = 0l;
		Long end = 0l;

		begin = Calendar.getInstance().getTimeInMillis();
		int srcRowcount = getSrcRowCount(srcTable);
		int destRowCount = getDestRowCount(srcTable);
		int count = 0;
		int temp = 0;

		if (srcRowcount > destRowCount) {
			System.out.println("elese block ");
			count = srcRowcount;
			temp = srcRowcount;
			System.out.println("count ::: " + count);
		} else {
			System.out.println("elese block ");
			count = destRowCount;
			temp = destRowCount;
			System.out.println("count ::: " + count);
		}

		// LinkedList<Integer> pages = new LinkedList<>();
		Map<Integer, Integer> pages = new HashMap<>();
		int i = 0;
		int j = 1;
		System.out.println("count ::: > " + count);
		while (count > 0) {
			count = count - 10;
			System.out.println(i + "==>" + count);

			if (count > 0)
				pages.put(j, i);
			// pages.add(i);
			j++;
			i++;
		}
		System.out.println(pages);
		// pages.pop();
		if (pages.size() == 0) {
			pages.put(1, 0);
		}

		System.out.println("currentPageNo --->" + currentPageNo);

		int startPage = pages.get(currentPageNo) * 10;
		int endPage = 0;
		try {

			endPage = pages.get(currentPageNo + 1) * 10;

		} catch (Exception e) {
			e.printStackTrace();
			endPage = temp;
		}

		HashMap<String, String> source_data = getSource(srcTable, srcColumn, srcKey, startPage, endPage);
		map.put("source_data", source_data);

		end = Calendar.getInstance().getTimeInMillis();
		System.out.println("Time for Source" + (end - begin));
		begin = Calendar.getInstance().getTimeInMillis();

		HashMap<String, String> dest_data = getDestination(destTable, destColumn, destKey, startPage, endPage);

		map.put("dest_data", dest_data);

		end = Calendar.getInstance().getTimeInMillis();
		System.out.println("Time for Destination" + (end - begin));

		begin = Calendar.getInstance().getTimeInMillis();
		Map<String, String> mismatch_data = source_data.entrySet().parallelStream().filter(
				e -> dest_data.get(e.getKey()) != null && !dest_data.get(e.getKey()).equalsIgnoreCase(e.getValue()))
				.collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getKey));
		end = Calendar.getInstance().getTimeInMillis();
		System.out.println("Time for Comparison" + (end - begin));

		map.put("mismatch_data", mismatch_data);

		// step5 close the connection object

		map.put("pages", pages.keySet());
		map.put("currentPageNo", currentPageNo);

		return map;
	}

	public HashMap<String, String> getSource(String srcTable, String srcColumn, String srcKey, int currentPageNo,
			int toPage) throws Exception {

		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();

		Statement stmt = con.createStatement();

		// step4 execute query
		// ResultSet rs_source = stmt.executeQuery("select " + srcColumn + " from " +
		// srcTable);

		ResultSet rs_source = stmt
				.executeQuery(" SELECT * FROM ( SELECT " + srcColumn + ", ROW_NUMBER() OVER (ORDER BY " + srcKey
						+ ") Row_Num FROM " + srcTable + ") WHERE Row_Num BETWEEN " + currentPageNo + " and " + toPage);

		ArrayList<String> rs_source_columns = new ArrayList<String>();
		ResultSetMetaData metadata = rs_source.getMetaData();
		int columnCount = metadata.getColumnCount();
		for (int i = 1; i <= columnCount; i++) {
			rs_source_columns.add(metadata.getColumnName(i));
		}
		HashMap<String, String> rs_source_data = new HashMap<String, String>();
		while (rs_source.next()) {
			StringBuffer coldata = new StringBuffer();
			for (String colName : rs_source_columns) {
				coldata.append(rs_source.getString(colName));
				coldata.append("#");
			}
			rs_source_data.put(rs_source.getString(srcKey), coldata.toString());

		}
		con.close();
		return rs_source_data;
	}

	public HashMap<String, String> getDestination(String destTable, String destColumn, String destKey,
			int currentPageNo, int toPage) throws Exception {

		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();

		Statement stmt = con.createStatement();

		// step4 execute query
		// ResultSet rs_dest = stmt.executeQuery("select " + destColumn + " from " +
		// destTable);

		String sql = "SELECT * FROM ( SELECT " + destColumn + ", ROW_NUMBER() OVER (ORDER BY " + destKey
				+ ") Row_Num FROM " + destTable + ") WHERE Row_Num BETWEEN " + currentPageNo + " and " + toPage;

		System.out.println(sql);

		ResultSet rs_dest = stmt.executeQuery(sql);

		ArrayList<String> rs_source_columns = new ArrayList<String>();
		ResultSetMetaData metadata = rs_dest.getMetaData();
		int columnCount = metadata.getColumnCount();
		for (int i = 1; i <= columnCount; i++) {
			rs_source_columns.add(metadata.getColumnName(i));
		}
		HashMap<String, String> rs_dest_data = new HashMap<String, String>();
		while (rs_dest.next()) {
			StringBuffer coldata = new StringBuffer();
			for (String colName : rs_source_columns) {
				coldata.append(rs_dest.getString(colName));
				coldata.append("#");
			}
			rs_dest_data.put(rs_dest.getString(destKey), coldata.toString());

		}
		con.close();
		return rs_dest_data;
	}

	public List<String> getSourceTables() {

		List<String> tables = new LinkedList<>();
		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");
			// Creating a Statement object
			Statement stmt = con.createStatement();
			// Retrieving the data
			ResultSet rs = stmt.executeQuery("SELECT table_name FROM user_tables ORDER BY table_name");
			System.out.println("Tables in the current database: ");
			while (rs.next()) {
				System.out.print(rs.getString(1));
				tables.add(rs.getString(1));
				System.out.println();
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		return tables;
	}

	public List<String> getDesticationTables() {

		List<String> tablesList = new LinkedList<>();
		try {

			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");
			// Retrieving the meta data object
//			DatabaseMetaData metaData = con.getMetaData();
//			String[] types = { "TABLE" };
//			// Retrieving the columns in the database
//			ResultSet tables = metaData.getTables(null, null, "%", types);
//
//			while (tables.next()) {
//				System.out.println(tables.getString("TABLE_NAME"));
//				tablesList.add(tables.getString("TABLE_NAME"));
//			}

			Statement stmt = con.createStatement();
			// Retrieving the data
			ResultSet rs = stmt.executeQuery("SELECT table_name FROM user_tables ORDER BY table_name");
			System.out.println("Tables in the current database: ");
			while (rs.next()) {
				System.out.print(rs.getString(1));
				tablesList.add(rs.getString(1));
				System.out.println();
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return tablesList;
	}

	public List<String> getSourceColumns(String tableName) {

		List<String> columns = new LinkedList<>();
		// Registering the Driver
		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery("SELECT *FROM " + tableName);
			ResultSetMetaData md = (ResultSetMetaData) rs.getMetaData();
			int counter = md.getColumnCount();

			System.out.println("The column names are as follows:");
			for (int loop = 1; loop <= counter; loop++) {

				columns.add(md.getColumnLabel(loop));

			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return columns;
	}

	public List<String> getDestinationColumns(String tableName) {

		List<String> columns = new LinkedList<>();
		// Registering the Driver
		try {
			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery("SELECT *FROM " + tableName);
			ResultSetMetaData md = (ResultSetMetaData) rs.getMetaData();
			int counter = md.getColumnCount();

			System.out.println("The column names are as follows:");
			for (int loop = 1; loop <= counter; loop++) {

				columns.add(md.getColumnLabel(loop));

			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return columns;
	}

	public List<String> getSourceTablesKey(String tableName) {

		List<String> tables = new LinkedList<>();
		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");
			// Creating a Statement object
			Statement stmt = con.createStatement();
			// Retrieving the data
			ResultSet rs = stmt
					.executeQuery("SELECT  cols.column_name FROM user_constraints cons, user_cons_columns cols "
							+ "WHERE cols.table_name = '" + tableName + "' " + "AND cons.constraint_type = 'P' "
							+ "AND cons.constraint_name = cols.constraint_name " + "AND cons.owner = cols.owner "
							+ "ORDER BY cols.table_name, cols.position ");

			System.out.println("Tables in the current database: ");
			while (rs.next()) {
				System.out.print(rs.getString(1));
				tables.add(rs.getString(1));
				System.out.println();
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return tables;
	}

	public List<String> getDestinationTablesKey(String tableName) {

		List<String> tables = new LinkedList<>();
		try {
			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");
			// Creating a Statement object
			Statement stmt = con.createStatement();
			// Retrieving the data
			ResultSet rs = stmt
					.executeQuery("SELECT  cols.column_name FROM all_constraints cons, all_cons_columns cols "
							+ "WHERE cols.table_name = '" + tableName + "' " + "AND cons.constraint_type = 'P' "
							+ "AND cons.constraint_name = cols.constraint_name " + "AND cons.owner = cols.owner "
							+ "ORDER BY cols.table_name, cols.position ");

			System.out.println("Tables in the current database: ");
			while (rs.next()) {
				System.out.print(rs.getString(1));
				tables.add(rs.getString(1));
				System.out.println();
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return tables;
	}

	public Map<String, Object> getSrcRow(String tableName, String columns, String tableKey, String keyValue)
			throws Exception {

		Map<String, Object> rowMap = new HashMap<>();
		// Registering the Driver
		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT " + columns + " FROM " + tableName + " WHERE " + tableKey + "= '" + keyValue+"'");
			ResultSetMetaData md = (ResultSetMetaData) rs.getMetaData();
			int counter = md.getColumnCount();

			System.out.println("The column names are as follows:");
			while (rs.next()) {
				for (int loop = 1; loop <= counter; loop++) {

					rowMap.put(md.getColumnLabel(loop), rs.getString(loop));

				}
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		System.out.println(rowMap);
		return rowMap;

	}

	public Map<String, Object> getDestRow(String tableName, String columns, String tableKey, String keyValue)
			throws Exception {

		Map<String, Object> rowMap = new HashMap<>();
		// Registering the Driver
		try {
			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT " + columns + " FROM " + tableName + " WHERE " + tableKey + "= '" + keyValue+"'");
			ResultSetMetaData md = (ResultSetMetaData) rs.getMetaData();
			int counter = md.getColumnCount();

			System.out.println("The column names are as follows:");
			while (rs.next()) {
				for (int loop = 1; loop <= counter; loop++) {

					rowMap.put(md.getColumnLabel(loop), rs.getString(loop));

				}
			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		System.out.println(rowMap);
		return rowMap;

	}

	public String updateSourceRowById(Map<String, Object> map) {

		String tableName = (String) map.get("tableName");
		String tableKey = (String) map.get("tableKey");
		String tableKeyValue = (String) map.get("tableKeyValue");

		Map<String, Object> rowMap = (Map<String, Object>) map.get("rowMap");
		try {

			for (String key : rowMap.keySet()) {
				DataSource ds = dataSource.sourceDataSource();
				Connection con = ds.getConnection();

				System.out.println("Connection established......");
				con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

				Statement stmt = con.createStatement();
				
				PreparedStatement ps = con
						.prepareStatement("UPDATE " + tableName + " SET " + key + " = ? WHERE " + tableKey + "= ?");

				ps.setObject(1, rowMap.get(key));

				ps.setObject(2, tableKeyValue);

				// String sql = "UPDATE "+tableName+" SET "+key+" = "+rowMap.get(key)+" WHERE
				// "+tableKey+"="+tableKeyValue;

				// System.out.println("==>"+sql);

				int i = ps.executeUpdate();

				System.out.println("updated " + i);
				// con.commit();

				con.close();
			}

		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";

		}

		return "success";
	}

	public String updateDestRowById(Map<String, Object> map) {

		String tableName = (String) map.get("tableName");
		String tableKey = (String) map.get("tableKey");
		String tableKeyValue = (String) map.get("tableKeyValue");

		Map<String, Object> rowMap = (Map<String, Object>) map.get("rowMap");
		try {

			for (String key : rowMap.keySet()) {

				DataSource ds = dataSource.destinationDataSource();
				Connection con = ds.getConnection();

				System.out.println("Connection established......");
				con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

				Statement stmt = con.createStatement();
				PreparedStatement ps = con
						.prepareStatement("UPDATE " + tableName + " SET " + key + " = ? WHERE " + tableKey + "= ?");

				ps.setObject(1, rowMap.get(key));

				ps.setObject(2, tableKeyValue);

				// String sql = "UPDATE "+tableName+" SET "+key+" = "+rowMap.get(key)+" WHERE
				// "+tableKey+"="+tableKeyValue;

				// System.out.println("==>"+sql);

				int i = ps.executeUpdate();

				System.out.println("updated " + i);
				// con.commit();

				con.close();

			}

		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";

		}

		return "success";
	}

	public String dataMigration(String srcTable, String destTable, String srcColumn, String destColumn, String srcKey,
			String destKey, String query) {
		System.out.println("-------------  Strat dataMigration--------------------- ");

		System.out.println(destColumn);
		try {

			Map<String, Map<String, Object>> map = getSourceData(srcTable, srcColumn, srcKey, query);

			String cols[] = srcColumn.split(",");

			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();

			System.out.println("Connection established......");

			con.prepareStatement("alter session set nls_date_format='yyyy-mm-dd hh24:mi:ss'").execute();

			for (String k : map.keySet()) {

				Map<String, Object> rowMap = map.get(k);

				Statement stmt = con.createStatement();
				String sql = "INSERT INTO " + destTable + " (" + destColumn + ") VALUES (";

				for (int i = 0; i < cols.length; i++) {

					String temp = (String) rowMap.get(cols[i].trim());
					String temp2 = null;

					if (i == cols.length - 1) {
						try {
							if (temp.equals("null")) {
								sql = sql + "," + temp2 + ")";
							} else
								sql = sql + ",'" + rowMap.get(cols[i].trim()) + "')";
						} catch (Exception e) {
							e.printStackTrace();
							sql = sql + "," + temp2 + ")";
						}
					} else if (i == 0) {
						try {
							if (temp.equals("null")) {
								sql = sql + temp2;
							} else
								sql = sql + "'" + rowMap.get(cols[i].trim()) + "'";
						} catch (Exception e) {
							e.printStackTrace();
							sql = sql + temp2;
						}
					} else {
						try {
							if (temp.equals("null")) {
								sql = sql + "," + temp2;
							} else
								sql = sql + ",'" + rowMap.get(cols[i].trim()) + "'";
						} catch (Exception e) {
							e.printStackTrace();
							sql = sql + "," + temp2;
						}
					}
				}

				System.out.println(sql);

				int i = stmt.executeUpdate(sql);

			}

			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			return "Migration fail with floowing error --> " + e;
		}

		System.out.println("-------------  end dataMigration--------------------- ");
		return "Migration success";

	}

	public HashMap<String, Map<String, Object>> getSourceData(String srcTable, String srcColumn, String srcKey,
			String query) throws Exception {

		System.out.println("-------------  Strat getSourceData--------------------- ");
		
		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		Statement stmt = con.createStatement();

		// step4 execute query
		ResultSet rs_source = stmt.executeQuery("select " + srcColumn + " from " + srcTable + " " + query);

		ArrayList<String> rs_source_columns = new ArrayList<String>();
		ResultSetMetaData metadata = rs_source.getMetaData();
		int columnCount = metadata.getColumnCount();
		for (int i = 1; i <= columnCount; i++) {
			rs_source_columns.add(metadata.getColumnName(i));
		}
		HashMap<String, Map<String, Object>> rs_source_data = new HashMap<>();

		while (rs_source.next()) {
			Map<String, Object> rowMap = new HashMap<>();
			for (String colName : rs_source_columns) {

				rowMap.put(colName, rs_source.getString(colName));
			}

			rs_source_data.put(rs_source.getString(srcKey), rowMap);

		}

		con.close();
		System.out.println("-------------  end getSourceData--------------------- ");
		return rs_source_data;
	}

	public List<Map<String, Object>> getCategory(String category) {

		List<Map<String, Object>> categorys = new LinkedList<>();

		try {

			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery("select * FROM  LIST_VALUES WHERE category='" + category + "'");

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					System.out.println("000 :: " + rs_source.getString(colName));

					map.put(colName, rs_source.getString(colName));
				}
				categorys.add(map);

				con.close();

			}

		} catch (Exception e) {
			e.printStackTrace();
		}

		return categorys;
	}

	public String saveRecommendedName(Map<String, Object> map) {
		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			String sql = "INSERT INTO CATEGORY_TRANACTION (CAT_USER, CAT_NAME, CAT_OLD_VALUE, CAT_REC_VALUE, CAT_STATUS, CAT_CATEGORY) VALUES"
					+ " ('" + map.get("CAT_USER") + "', '" + map.get("CAT_NAME") + "', '" + map.get("CAT_OLD_VALUE")
					+ "', '" + map.get("CAT_REC_VALUE") + "', '" + map.get("CAT_STATUS") + "', '"
					+ map.get("CAT_CATEGORY") + "')";
			int i = stmt.executeUpdate(sql);
			System.out.println("i ===> " + i);
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";
		}
		return "Success";
	}

	public List<Map<String, Object>> getCategoryRecommendedList(String NAME) {

		List<Map<String, Object>> categorys = new LinkedList<>();

		try {

			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery(
					"select CAT_USER,CAT_NAME,CAT_OLD_VALUE,CAT_REC_VALUE,CAT_STATUS,cat_category from CATEGORY_TRANACTION WHERE cat_name='"
							+ NAME + "'");

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					System.out.println("000 :: " + rs_source.getString(colName));

					map.put(colName, rs_source.getString(colName));
				}
				categorys.add(map);

			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		return categorys;
	}

	public String approveCategoryValue(Map<String, Object> map) {

		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			String sql = "UPDATE CATEGORY_TRANACTION SET CAT_STATUS = '" + map.get("CAT_STATUS")
					+ "' WHERE CAT_USER = '" + map.get("CAT_USER") + "' AND CAT_OLD_VALUE = '"
					+ map.get("CAT_OLD_VALUE") + "' AND CAT_NAME='" + map.get("CAT_NAME") + "'";
			int i = stmt.executeUpdate(sql);

			int j = stmt.executeUpdate("UPDATE LIST_VALUES SET VALUE = '" + map.get("CAT_REC_VALUE")
					+ "' WHERE NAME = '" + map.get("CAT_NAME") + "'");

			System.out.println("updated " + i);

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";
		}

		return "Success";
	}

	public List<Map<String, Object>> getCategories() {

		List<Map<String, Object>> categorys = new LinkedList<>();

		try {

			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery("select DISTINCT CATEGORY from LIST_VALUES");

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					System.out.println("000 :: " + rs_source.getString(colName));

					map.put(colName, rs_source.getString(colName));
				}
				categorys.add(map);

			}

			con.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		return categorys;
	}

	public int getSrcRowCount(String table) throws Exception {

		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		Statement stmt = con.createStatement();

		ResultSet rs = stmt.executeQuery("select count(*) from " + table);
		rs.next();
		int count = rs.getInt(1);
		System.out.println(count);

		con.close();

		return count;
	}

	public int getDestRowCount(String table) throws Exception {

		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		Statement stmt = con.createStatement();

		ResultSet rs = stmt.executeQuery("select count(*) from " + table);
		rs.next();
		int count = rs.getInt(1);
		System.out.println(count);

		con.close();

		return count;
	}

	public Map<String, Object> getSrcTablesHierarchy() throws Exception {

		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();

		System.out.println("Connection established......");

		return getTablesHierarchy(con);

	}

	public Map<String, Object> getDestTablesHierarchy() throws Exception {

		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();

		System.out.println("Connection established......");

		return getTablesHierarchy(con);

	}

	public Map<String, Object> getTablesHierarchy(Connection con) throws Exception {

		Statement stmt = con.createStatement();

		Map<String, Object> map = new HashMap<>();

		// step4 execute query
		ResultSet rs_root_tables = stmt.executeQuery("select user_tables.table_name,constraint_name"
				+ " from user_tables left outer join user_constraints on user_tables.table_name = user_constraints.table_name and constraint_type = 'P' ");

		Map<String, String> tableHierarchy = new HashMap<String, String>();
		while (rs_root_tables.next()) {
			tableHierarchy.put(rs_root_tables.getString("table_name"), rs_root_tables.getString("constraint_name"));

		}

		for (String key : tableHierarchy.keySet()) {

			if (tableHierarchy.get(key) != null) {
				Map<String, String> childTables = getChildTables(con, tableHierarchy, key, tableHierarchy.get(key));
				map.put(key, childTables);
			}

		}

		return map;
	}

	public static Map<String, String> getChildTables(Connection con, Map<String, String> tableHierarchy,
			String tableName, String constraintName) {
		Map<String, String> childTables = new HashMap<String, String>();

		try {
			PreparedStatement ps = con.prepareStatement(
					"select table_name,constraint_name from user_constraints where constraint_type = 'R' and r_constraint_name = ?");
			ps.setString(1, constraintName);
			ResultSet rs = ps.executeQuery();
			if (rs != null) {

				while (rs.next()) {

					childTables.put(rs.getString("table_name"), rs.getString("constraint_name"));

				}
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return childTables;
	}

	public String saveRule(Map<String, Object> map) {

		try {
			DataSource ds = dataSource.appDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();
			String sql = "INSERT INTO RULES (SRCTBL, DESTTBL, SRC_KEY, DEST_KEY, RULE_NAME, VALUE1, VALUE2, VALUE3,FILTER_CONDITION) VALUES ('"
					+ map.get("srcTbl") + "', '" + map.get("destTbl") + "', '" + map.get("ruleSrcKey") + "', '"
					+ map.get("ruleDestKey") + "', '" + map.get("applyRule") + "', '" + map.get("ruleValue1") + "', '"
					+ map.get("ruleValue2") + "', '" + map.get("ruleValue3") + "',?)";
			// int i = stmt.executeUpdate(sql);

			PreparedStatement ps = con.prepareStatement(
					"INSERT INTO RULES (SRCTBL, DESTTBL, SRC_KEY, DEST_KEY, RULE_NAME, VALUE1, VALUE2, VALUE3, FILTER_CONDITION,SRC_COLUMNS,DEST_COLUMNS,VALUE4,STATUS) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)");

			ps.setObject(1, map.get("srcTbl"));
			ps.setObject(2, map.get("destTbl"));
			ps.setObject(3, map.get("ruleSrcKey"));
			ps.setObject(4, map.get("ruleDestKey"));
			ps.setObject(5, map.get("applyRule"));
			ps.setObject(6, map.get("ruleValue1"));
			ps.setObject(7, map.get("ruleValue2"));
			ps.setObject(8, map.get("ruleValue3"));
			ps.setObject(9, map.get("filterCondition"));
			ps.setObject(10, map.get("SRC_COLUMNS"));
			ps.setObject(11, map.get("DEST_COLUMNS"));
			ps.setObject(12, map.get("ruleValue4"));
			ps.setString(13, "PENDING");

			int i = ps.executeUpdate();

			System.out.println("i ===> " + i);
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";
		}
		return "Success";

	}

	public String migrateBasedOnIgnoreColumnRule(Map<String, String> map) throws SQLException, ClassNotFoundException {

		try {
			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("source Connection established......");

			con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			String sourceTable = (String) map.get("sourceTable");// "EMPLOYEES_SOURCE";
			String destTable = (String) map.get("destTable");// "EMPLOYEES_DEST";
			String value1 = (String) map.get("value1");

			String srcCols = null;
			String destCols = null;
			String srcColsArray[] = null;
			String destColsArray[] = null;

			srcCols = (String) map.get("SRC_COLUMNS");
			destCols = (String) map.get("DEST_COLUMNS");

			if (srcCols != null) {
				srcColsArray = srcCols.split(",");
			}
			if (destCols != null) {
				destColsArray = destCols.split(",");
			}

			List<String> columnsToIgnore = new LinkedList<>();// getIgnoreColumnsList(con, sourceTable, destTable,
																// ruleName);

			String[] ls = value1.split(",");

			for (String col : ls) {
				columnsToIgnore.add(col);
			}

			String whereCondition = (String) map.get("whereCondition");

			List<String> sourceColumns = new ArrayList<String>();

			if (srcCols != null) {

				for (String col : srcColsArray) {
					// if (!columnsToIgnore.contains(col))
					sourceColumns.add(col);
				}
			}

			else {

				ResultSet res = con.getMetaData().getColumns(null, null, sourceTable, null);
				while (res.next()) {
					String sourceColumn = res.getString("COLUMN_NAME");
					if (!columnsToIgnore.contains(sourceColumn))
						sourceColumns.add(sourceColumn);
				}

			}
			// System.out.println(sourceColumns);

			StringBuffer sourceTableData = new StringBuffer();
			sourceTableData.append("SELECT ");
			for (String c : sourceColumns) {
				sourceTableData.append(c);
				sourceTableData.append(",");
			}

			sourceTableData.deleteCharAt(sourceTableData.length() - 1);

			sourceTableData.append(" FROM " + sourceTable);

			if (whereCondition != null) {
				sourceTableData.append(" " + whereCondition);
			}

			System.out.println(sourceTableData.toString());

			StringBuffer insertTargetTableData = new StringBuffer();

			insertTargetTableData.append("INSERT INTO ");
			insertTargetTableData.append(destTable);
			insertTargetTableData.append("(");

			if (destCols != null) {

				for (String c : destColsArray) {
					insertTargetTableData.append(c);
					insertTargetTableData.append(",");
				}

			} else {

				for (String c : sourceColumns) {
					insertTargetTableData.append(c);
					insertTargetTableData.append(",");
				}

			}

			insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			insertTargetTableData.append(") VALUES (");

			if (destCols != null) {

				for (String c : destColsArray) {
					insertTargetTableData.append("?");
					insertTargetTableData.append(",");
				}

			} else {
				for (String c : sourceColumns) {
					insertTargetTableData.append("?");
					insertTargetTableData.append(",");
				}
			}
			insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			insertTargetTableData.append(")");

			DataSource ds2 = dataSource.destinationDataSource();
			Connection con2 = ds2.getConnection();
			System.out.println("destication Connection established......");
			con2.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			System.out.println(insertTargetTableData.toString());
			PreparedStatement psTargetData = con2.prepareStatement(insertTargetTableData.toString());

			ResultSet processSourceData = (con.prepareStatement(sourceTableData.toString())).executeQuery();
			while (processSourceData.next()) {
				for (int i = 0; i < sourceColumns.size(); i++) {
					// System.out.println(processSourceData.getString(i+1));
					psTargetData.setString(i + 1, processSourceData.getString(i + 1));
				}
				psTargetData.execute();

			}
			con.close();
			con2.close();
			System.out.println("Done");
			return "Migration success";
		} catch (Exception e) {
			e.printStackTrace();
			return "Migration failed due to " + e;
		}

	}

	public List<Map<String, String>> getRules() {

		List<Map<String, String>> rules = new LinkedList<>();

		try {

			DataSource ds = dataSource.appDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery("select * from rules where STATUS='PENDING'");

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, String> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

	public String migrateBasedOnSplitRule(Map<String, String> map) throws SQLException, ClassNotFoundException {

		try {

			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			String sourceTable = map.get("sourceTable"); // "SPLIT_SRC";//"EMPLOYEES_SOURCE";
			String destTable = map.get("destTable");// "SPLIT_DEST";//"EMPLOYEES_DEST";
			String columnToSplit = map.get("value1");// "FULL_NAME";
			String splitString = map.get("value2");

			String mappedSrcCols = map.get("SRC_COLUMNS");

			String mappedSrcColsArray[] = null;
			if (mappedSrcCols != null)
				mappedSrcColsArray = mappedSrcCols.split(",");

			String mappedDestCols = map.get("DEST_COLUMNS");

			String mappedDestColsArray[] = null;
			if (mappedDestCols != null)
				mappedDestColsArray = mappedDestCols.split(",");

			List<String> destColsList = new LinkedList<>();

			String tempCols = map.get("value3");

			if (mappedDestColsArray != null)
				for (String col : mappedDestColsArray) {

					if (!tempCols.contains(col))
						destColsList.add(col);
				}

			String cols[] = tempCols.split(",");

			String whereCondition = map.get("whereCondition");
			List<String> splitColumns = new ArrayList<String>();
			for (String col : cols) {
				splitColumns.add(col);
				destColsList.add(col);
			}

			List<String> sourceColumns = new ArrayList<String>();

			if (mappedSrcCols != null) {
				for (String col : mappedSrcColsArray) {

					if (!columnToSplit.equalsIgnoreCase(col))
						sourceColumns.add(col);
				}
			} else {

				ResultSet res = con.getMetaData().getColumns(null, null, sourceTable, null);
				while (res.next()) {
					String sourceColumn = res.getString("COLUMN_NAME");

					if (!columnToSplit.equalsIgnoreCase(sourceColumn))
						sourceColumns.add(sourceColumn);
				}
			}
			sourceColumns
					.add("SUBSTR(" + columnToSplit + ",1," + "INSTR(" + columnToSplit + ",'" + splitString + "')-1)");
			sourceColumns.add("SUBSTR(" + columnToSplit + ",INSTR(" + columnToSplit + ",'" + splitString + "')+1)");

			System.out.println(sourceColumns);

			StringBuffer sourceTableData = new StringBuffer();
			sourceTableData.append("SELECT ");
			for (String c : sourceColumns) {

				sourceTableData.append(c);
				sourceTableData.append(",");

			}

			sourceTableData.deleteCharAt(sourceTableData.length() - 1);

			sourceTableData.append(" FROM " + sourceTable);

			if (whereCondition != null) {
				sourceTableData.append(" " + whereCondition);
			}

			System.out.println("sourceTableData ==>" + sourceTableData);
			System.out.println("destColsList ==>" + destColsList);

			StringBuffer insertTargetTableData = new StringBuffer();

			insertTargetTableData.append("INSERT INTO ");
			insertTargetTableData.append(destTable);

			insertTargetTableData.append("(");

			if (destColsList.size() > 0) {

				for (String c : destColsList) {

					insertTargetTableData.append(c);
					insertTargetTableData.append(",");

				}
				insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);

			} else {

				sourceColumns.remove(sourceColumns.size() - 2);
				sourceColumns.remove(sourceColumns.size() - 1);
				for (String c : splitColumns) {
					sourceColumns.add(c);
				}

				System.out.println(sourceColumns);

				for (String c : sourceColumns) {

					insertTargetTableData.append(c);
					insertTargetTableData.append(",");

				}

				insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			}
			insertTargetTableData.append(") VALUES (");

			if (destColsList.size() > 0) {
				for (String c : destColsList) {

					insertTargetTableData.append("?");
					insertTargetTableData.append(",");

				}
			} else {

				for (String c : sourceColumns) {

					insertTargetTableData.append("?");
					insertTargetTableData.append(",");

				}

			}
			insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			insertTargetTableData.append(")");

			DataSource ds2 = dataSource.destinationDataSource();
			Connection con2 = ds2.getConnection();
			System.out.println("destication Connection established......");
			con2.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			PreparedStatement psTargetData = con2.prepareStatement(insertTargetTableData.toString());

			System.out.println(insertTargetTableData);

			ResultSet processSourceData = (con.prepareStatement(sourceTableData.toString())).executeQuery();
			while (processSourceData.next()) {
				for (int i = 0; i < sourceColumns.size(); i++) {
					System.out.println(processSourceData.getString(i + 1));
					psTargetData.setString(i + 1, processSourceData.getString(i + 1));
				}
				psTargetData.execute();

			}
			System.out.println("Done");
			con.close();
			con2.close();
			return "Migration success";

		} catch (Exception e) {
			e.printStackTrace();
			return "Unable to migrate data " + e;

		}

	}

	public String migrateBasedOnMergeColumnsRule(Map<String, String> map) throws SQLException, ClassNotFoundException {

		try {

			DataSource ds = dataSource.sourceDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			String sourceTable = map.get("sourceTable"); // "SPLIT_SRC";//"EMPLOYEES_SOURCE";
			String destTable = map.get("destTable");// "SPLIT_DEST";//"EMPLOYEES_DEST";

			String mappedSrcCols = map.get("SRC_COLUMNS");

			String mappedSrcColsArray[] = null;
			if (mappedSrcCols != null)
				mappedSrcColsArray = mappedSrcCols.split(",");

			String mappedDestCols = map.get("DEST_COLUMNS");

			String mappedDestColsArray[] = null;
			if (mappedDestCols != null)
				mappedDestColsArray = mappedDestCols.split(",");

			String tempCols = map.get("value1");
			String cols[] = tempCols.split(",");

			String whereCondition = map.get("whereCondition");

			List<String> columnsToMerge = new ArrayList<String>();

			for (String col : cols) {
				columnsToMerge.add(col);
			}

			String mergeOperator = "||' '||";
			String targetMergedColumn = map.get("value3");

			List<String> sourceColumns = new ArrayList<String>();

			if (mappedSrcCols != null) {

				for (String col : mappedSrcColsArray) {
					if (!columnsToMerge.contains(col))
						sourceColumns.add(col);
				}

			} else {
				ResultSet res = con.getMetaData().getColumns(null, null, sourceTable, null);
				while (res.next()) {
					String sourceColumn = res.getString("COLUMN_NAME");
					if (!columnsToMerge.contains(sourceColumn))
						sourceColumns.add(sourceColumn);
				}
			}

			StringBuffer colMergeStr = new StringBuffer();
			for (int i = 0; i < columnsToMerge.size() - 1; i++) {
				colMergeStr.append(columnsToMerge.get(i) + mergeOperator);
			}
			colMergeStr.append(columnsToMerge.get(columnsToMerge.size() - 1));
			sourceColumns.add(colMergeStr.toString());

			System.out.println("-->" + sourceColumns);

			StringBuffer sourceTableData = new StringBuffer();
			sourceTableData.append("SELECT ");
			for (String c : sourceColumns) {
				sourceTableData.append(c);
				sourceTableData.append(",");
			}

			sourceTableData.deleteCharAt(sourceTableData.length() - 1);

			sourceTableData.append(" FROM " + sourceTable);

			if (whereCondition != null) {
				sourceTableData.append(" " + whereCondition);
			}

			System.out.println(sourceTableData);

			StringBuffer insertTargetTableData = new StringBuffer();

			insertTargetTableData.append("INSERT INTO ");
			insertTargetTableData.append(destTable);

			insertTargetTableData.append("(");
			sourceColumns.remove(sourceColumns.size() - 1);
			sourceColumns.add(targetMergedColumn);

			System.out.println("==>" + sourceColumns);

			if (mappedDestCols != null) {
				for (String c : sourceColumns) {
					insertTargetTableData.append(c);
					insertTargetTableData.append(",");
				}
			} else {
				for (String c : sourceColumns) {
					insertTargetTableData.append(c);
					insertTargetTableData.append(",");
				}
			}

			insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			insertTargetTableData.append(") VALUES (");

			if (mappedDestCols != null) {
				for (String c : mappedDestColsArray) {
					insertTargetTableData.append("?");
					insertTargetTableData.append(",");
				}
			} else {
				for (String c : sourceColumns) {

					insertTargetTableData.append("?");
					insertTargetTableData.append(",");
				}
			}
			insertTargetTableData.deleteCharAt(insertTargetTableData.length() - 1);
			insertTargetTableData.append(")");

			DataSource ds2 = dataSource.destinationDataSource();
			Connection con2 = ds2.getConnection();
			System.out.println("destication Connection established......");
			con2.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			PreparedStatement psTargetData = con2.prepareStatement(insertTargetTableData.toString());

			ResultSet processSourceData = (con.prepareStatement(sourceTableData.toString())).executeQuery();
			while (processSourceData.next()) {
				for (int i = 0; i < sourceColumns.size(); i++) {

					psTargetData.setString(i + 1, processSourceData.getString(i + 1));
				}
				System.out.println(sourceTableData);
				System.out.println(insertTargetTableData);
				psTargetData.execute();

			}
			System.out.println("Done");

			con.close();
			con2.close();
			return "Migration success";

		} catch (Exception e) {
			e.printStackTrace();
			return "Unable to migrate data " + e;

		}

	}

	public String migrateBasedOnScalarColumnsRule(Map<String, String> dataMap)
			throws SQLException, ClassNotFoundException {

		String srcTbl = dataMap.get("sourceTable");
		String srcTblCols = dataMap.get("SRC_COLUMNS");

		String sumCols = dataMap.get("value1");

		String srcTblKry = dataMap.get("srcKey");

		String srcTblColsArray[] = srcTblCols.split(",");

		List<String> srcTblColsList = new LinkedList<>();

		for (String col : srcTblColsArray) {
			if (!sumCols.contains(col)) {
				srcTblColsList.add(col);
			}
		}

		srcTblCols = srcTblColsList.toString();

		String destTbl = dataMap.get("destTable");
		String destTblCols = dataMap.get("DEST_COLUMNS");

		String destSumCol = dataMap.get("value2");

		String destTblColsArray[] = destTblCols.split(",");

		List<String> destTblColsList = new LinkedList<>();

		for (String col : destTblColsArray) {
			if (!sumCols.contains(col)) {
				destTblColsList.add(col);
			}
		}

		destTblCols = destTblColsList.toString();

		destTblCols = destTblCols.replace("[", "");
		destTblCols = destTblCols.replace("]", "");

		List<Map<String, Object>> list = getSrcColsForScalarRule(srcTbl, srcTblCols, srcTblKry);

		int i = 0;
		for (Map<String, Object> map : list) {

			i = instertDestSumRuleData(destTbl, destTblCols, destSumCol, map, srcTbl, sumCols, srcTblKry);
		}

		if (i == 1) {
			System.out.println("Migration success");
		}
		return "Migration success";

	}

	public int instertDestSumRuleData(String destTbl, String destTblCols, String destSumCol, Map<String, Object> map,
			String srcTbl, String sumCols, String srcTblKry) throws ClassNotFoundException, SQLException {

		System.out.println("--------------instertDestSumRuleData  start------------------");

		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		String tempDestCols = destTblCols + "," + destSumCol;

		String tempDestColsArray[] = destTblCols.split(",");

		String sql1 = "INSERT INTO " + destTbl + " ( " + tempDestCols + ") VALUES (";

		String sql2 = "";

		for (String col : tempDestColsArray) {
			sql2 = sql2 + "?,";
		}
		sql2 = sql2 + "? )";

		String finalsql = sql1 + sql2;

		System.out.println(finalsql);

		tempDestColsArray = tempDestCols.split(",");
		try {

			PreparedStatement ps = con.prepareStatement(finalsql);

			int i = 1;

			for (String col : tempDestColsArray) {
				String temp = col.trim();
				if (temp.equals(destSumCol)) {

					ps.setObject(i, getSumOfCols(srcTbl, sumCols, srcTblKry, map.get(srcTblKry)));
				} else {
					ps.setObject(i, map.get(temp));
				}

				i++;

			}
			int j = ps.executeUpdate();

		} catch (Exception e) {
			e.printStackTrace();
			con.close();
			return 0;
		}

		System.out.println("--------------instertDestSumRuleData  end------------------");
		con.close();
		return 1;
	}

	public long getSumOfCols(String tblName, String cols, String tblKey, Object keyValue)
			throws ClassNotFoundException, SQLException {

		System.out.println("=====================getSingleValue start============================");

		long value = 0;
		Statement stmt = null;

		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		String temp = cols.replace(",", "+");

		String sql = "SELECT SUM(" + temp + ") from " + tblName + " where " + tblKey + "=" + keyValue;
		System.out.println(sql);
		try {
			stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery(sql);

			while (rs.next())
				value = value + rs.getLong(1);
		}

		catch (SQLException e) {
			e.printStackTrace();
			con.close();
		}
		System.out.println("=====================getSingleValue end============================");
		
		con.close();

		return value;

	}

	public List<Map<String, Object>> getSrcColsForScalarRule(String srcTbl, String srcTblCols, String srcTblKry)
			throws ClassNotFoundException, SQLException {

		List<Map<String, Object>> rules = new LinkedList<>();
		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			srcTblCols = srcTblCols.replace("[", "");
			srcTblCols = srcTblCols.replace("]", "");

			String sql = "select " + srcTblCols + " from " + srcTbl;
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

	public String migrateBasedOnAggregateColumnsRule(Map<String, String> map)
			throws SQLException, ClassNotFoundException {

		String srcTbl = map.get("sourceTable");

		String srcCols = map.get("SRC_COLUMNS");

		String aggFunCol = map.get("value1");

		String groupBy = map.get("value3");

		String aggFuntiong = map.get("value4");

		String destTbl = map.get("destTable");

		String destCols = map.get("DEST_COLUMNS");

		String destAggCol = map.get("value2");

		String destColsArray[] = destCols.split(",");

		List<String> destColsList = new LinkedList<>();

		try {

			for (String col : destColsArray) {

				if (!col.equals(destAggCol)) {
					destColsList.add(col);
				}

			}

			String destFinalScrCols = destColsList.toString();

			destFinalScrCols = destFinalScrCols.replace("[", "");
			destFinalScrCols = destFinalScrCols.replace("]", "");

			List<Map<String, Object>> list = getSrcAggRuleData(srcTbl, srcCols);

			for (Map<String, Object> map2 : list) {
				int i = instertDestSumRuleData(destTbl, destFinalScrCols, map2);
			}

			List<Map<String, Object>> aggList = getAggRuleData(srcTbl, aggFunCol, groupBy, aggFuntiong);

			DataSource ds = dataSource.destinationDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

			for (Map<String, Object> map2 : aggList) {

				String finalsql = "UPDATE EMP_SCLAR_DEST SET SUM_AMOUNT ='" + map2.get("RES") + "' WHERE BONUS ='"
						+ map2.get(groupBy) + "'";

				System.out.println(finalsql);

				Statement st = con.createStatement();

				int j = st.executeUpdate(finalsql);
			}

			System.out.println("done");
			con.close();

		} catch (Exception e) {
			e.printStackTrace();
			
			return "Migration fail";
		}

		return "Migration success";

	}

	public List<Map<String, Object>> getAggRuleData(String srcTbl, String aggFunCol, String groupBy, String aggFuntiong)
			throws ClassNotFoundException, SQLException {

		List<Map<String, Object>> rules = new LinkedList<>();

		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			String sql = "select " + groupBy + ", " + aggFuntiong + "(" + aggFunCol + ") as res from " + srcTbl
					+ " group by " + groupBy;
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

	public List<Map<String, Object>> getSrcAggRuleData(String srcTbl, String srcTblCols) throws ClassNotFoundException, SQLException {

		List<Map<String, Object>> rules = new LinkedList<>();
		DataSource ds = dataSource.sourceDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			srcTblCols = srcTblCols.replace("[", "");
			srcTblCols = srcTblCols.replace("]", "");

			String sql = "select " + srcTblCols + " from " + srcTbl;
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			con.close();
		}

		con.close();
		return rules;
	}

	public int instertDestSumRuleData(String destTbl, String destTblCols, Map<String, Object> map)
			throws ClassNotFoundException, SQLException {

		System.out.println("--------------instertDestSumRuleData  start------------------");
		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		String tempDestColsArray[] = destTblCols.split(",");

		String sql1 = "INSERT INTO " + destTbl + " ( " + destTblCols + ") VALUES (";

		String sql2 = "";

		for (String col : tempDestColsArray) {
			sql2 = sql2 + "?,";
		}

		StringBuilder sb = new StringBuilder(sql2);
		sb.deleteCharAt(sb.length() - 1);
		sb.append(")");
		sql2 = sb.toString();

		String finalsql = sql1 + sql2;

		System.out.println(finalsql);

		tempDestColsArray = destTblCols.split(",");
		try {

			PreparedStatement ps = con.prepareStatement(finalsql);

			int i = 1;

			for (String col : tempDestColsArray) {
				String temp = col.trim();

				ps.setObject(i, map.get(temp));

				i++;

			}
			int j = ps.executeUpdate();

		} catch (Exception e) {
			e.printStackTrace();
			con.close();
			return 0;
		}

		System.out.println("--------------instertDestSumRuleData  end------------------");
		con.close();
		return 1;
	}

	public List<String> getDBFunctions() throws SQLException {
		List<String> functions = new LinkedList<>();

		DataSource ds = dataSource.appDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			String sql = "select FUNCTION_NAME from DB_FUNCTIONS_MASTER";
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			
			
			
			while (rs_source.next()) {
				
				functions.add(rs_source.getString(1));

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			con.close();
		}
		con.close();
		System.out.println(functions);
		return functions;
	}

	public List<String> getMasterRules() throws SQLException {


		List<String> rules = new LinkedList<>();

		DataSource ds = dataSource.appDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			String sql = "select RULE from RULE_MASTER";
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			
			
			
			while (rs_source.next()) {
				
				rules.add(rs_source.getString(1));

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			con.close();
		}
		con.close();
		System.out.println(rules);
		return rules;
		
	}

	public String migrateBasedOnDefaultCaseRule(Map<String, String> map) {
		
		String srcTbl = map.get("sourceTable");

		String srcCols = map.get("SRC_COLUMNS");

		String defaultCase = map.get("value1");

		
		String destTbl = map.get("destTable");

		String destCols = map.get("DEST_COLUMNS");

		try {

			List<Map<String, Object>> list = getSrcAggRuleData(srcTbl, srcCols);

			for (Map<String, Object> map2 : list) {
				int i = instertDestDefaultRuleData(destTbl, destCols, map2,defaultCase);
			}

		
			

		} catch (Exception e) {
			e.printStackTrace();
			
			return "Migration fail "+e;
		}

		return "Migration success";
	}
	
	public int instertDestDefaultRuleData(String destTbl, String destTblCols, Map<String, Object> map, String defaultCase)
			throws ClassNotFoundException, SQLException {

		System.out.println("--------------instertDestSumRuleData  start------------------");
		DataSource ds = dataSource.destinationDataSource();
		Connection con = ds.getConnection();
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		String tempDestColsArray[] = destTblCols.split(",");

		String sql1 = "INSERT INTO " + destTbl + " ( " + destTblCols + ") VALUES (";

		String sql2 = "";

		for (String col : tempDestColsArray) {
			sql2 = sql2 + "?,";
		}

		StringBuilder sb = new StringBuilder(sql2);
		sb.deleteCharAt(sb.length() - 1);
		sb.append(")");
		sql2 = sb.toString();

		String finalsql = sql1 + sql2;

		System.out.println(finalsql);

		tempDestColsArray = destTblCols.split(",");
		try {

			PreparedStatement ps = con.prepareStatement(finalsql);

			int i = 1;

			for (String col : tempDestColsArray) {
				String temp = col.trim();
				try {
				if(map.get(temp).equals(null)) {
					ps.setObject(i, defaultCase);
				}
				else
				ps.setObject(i, map.get(temp));
				}catch (Exception e) {
					ps.setObject(i, defaultCase);
				}

				i++;

			}
			int j = ps.executeUpdate();

		} catch (Exception e) {
			e.printStackTrace();
			con.close();
			return 0;
		}

		System.out.println("--------------instertDestSumRuleData  end------------------");
		con.close();
		return 1;
	}
	
	
	public void jobStart() throws ClassNotFoundException, SQLException {
		
		System.out.println("-----------------jobStart-------------------");

		
		List<Map<String, String>> rulesList = getRules();
		
		for (Map<String, String> mainMap : rulesList) {
		
			System.out.println(mainMap);
			
			Map<String, String> map = new HashMap<>();
			
			map.put("sourceTable", mainMap.get("SRCTBL"));
			map.put("destTable", mainMap.get("DESTTBL"));
			map.put("srcKey", mainMap.get("SRC_KEY"));
			map.put("destKey", mainMap.get("DEST_KEY"));
			map.put("ruleName", mainMap.get("RULE_NAME"));
			map.put("value1", mainMap.get("VALUE1"));
			map.put("value2", mainMap.get("VALUE2"));
			map.put("value3", mainMap.get("VALUE3"));
			map.put("whereCondition", mainMap.get("FILTER_CONDITION"));
			map.put("SRC_COLUMNS", mainMap.get("SRC_COLUMNS"));
			map.put("DEST_COLUMNS", mainMap.get("DEST_COLUMNS"));
			map.put("value4", mainMap.get("VALUE4"));
						
			String rule = (String) map.get("ruleName");
			System.out.println("-->"+rule);
			
			if(rule.equals("IgnoreColumns")){

			     
			      String status = migrateBasedOnIgnoreColumnRule(map);
			      
			      System.out.println(status);
			      
			    	  updateRuleStatus(mainMap.get("ID"),status);
			     
			    }

			    else if(rule.equals("SplitColumns")){

			    	String status = migrateBasedOnSplitRule(map);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);
			    }

			    else if(rule.equals("MergeColumns")){

			    	String status = migrateBasedOnMergeColumnsRule(map);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);

			    }

			    else if(rule.equals("Scalar")){

			    	String status = migrateBasedOnScalarColumnsRule(map);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);

			    }
			    else if(rule.equals("AggregateColumns")){

			    	String status = migrateBasedOnAggregateColumnsRule(map);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);

			    }

			    else if(rule.equals("DefaultCase")){

			    	String status = migrateBasedOnDefaultCaseRule(map);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);

			    }
			    else if(rule.equals("Mapping")){
			    	
					String condition = "";
					
					if(map.get("whereCondition")!=null) {
						condition = map.get("whereCondition");
					}

			    	String status = dataMigration(map.get("sourceTable"), map.get("destTable"), map.get("SRC_COLUMNS"), map.get("DEST_COLUMNS"), map.get("srcKey"), map.get("destKey"), condition);
			    	 System.out.println(status);
			    	
				    	  updateRuleStatus(mainMap.get("ID"),status);

			    }
			
			
		}
		
	}

	public List<String> getSourceColumnsBySql(String srcTable) {

		try {

			DataSource ds = dataSource.appDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery(srcTable);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			con.close();
			return rs_source_columns;

		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}
	
	public String updateRuleStatus(String id, String status) {

		try {
			DataSource ds = dataSource.appDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

	
			PreparedStatement ps = con.prepareStatement("UPDATE RULES SET STATUS =?  WHERE ID=?");

			ps.setString(1, status);
			ps.setString(1, id);

			int i = ps.executeUpdate();

			System.out.println("i ===> " + i);
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
			return "Fail";
		}
		return "Success";

	}
	
	public List<Map<String, String>> getRulesStatus() {

		List<Map<String, String>> rules = new LinkedList<>();

		try {

			DataSource ds = dataSource.appDataSource();
			Connection con = ds.getConnection();
			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			ResultSet rs_source = stmt.executeQuery("select * from rules where STATUS !='PENDING'");

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, String> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

}
