package com.demo.service;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.PropertySource;
import org.springframework.core.env.Environment;

public class Test {

	public static void main(String[] args) throws SQLException, ClassNotFoundException {

		String srcTbl = "EMP_SCLAR_SRC";

		String srcCols = "EMPLOYEE_ID,FIRST_NAME,LAST_NAME,EMAIL,PHONE_NUMBER,SALARY,BONUS";

		String aggFunCol = "SALARY";

		String groupBy = "BONUS";

		String aggFuntiong = "SUM";

		String destTbl = "EMP_SCLAR_DEST";

		String destCols = "EMPLOYEE_ID,FIRST_NAME,LAST_NAME,EMAIL,PHONE_NUMBER,SALARY,BONUS,SUM_AMOUNT";

		String destAggCol = "SUM_AMOUNT";

		String destColsArray[] = destCols.split(",");

		List<String> destColsList = new LinkedList<>();

		for (String col : destColsArray) {

			if (!col.equals(destAggCol)) {
				destColsList.add(col);
			}

		}

		String destFinalScrCols = destColsList.toString();

		destFinalScrCols = destFinalScrCols.replace("[", "");
		destFinalScrCols = destFinalScrCols.replace("]", "");
		

		List<Map<String, Object>> list = getSrcAggRuleData(srcTbl, srcCols, aggFunCol, groupBy);

		for (Map<String, Object> map : list) {
			int i = instertDestSumRuleData(destTbl, destFinalScrCols, map);
		}

		List<Map<String, Object>> aggList = getAggRuleData(srcTbl, aggFunCol, groupBy, aggFuntiong);


		Class.forName("oracle.jdbc.driver.OracleDriver");

		Connection con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl", "hr", "Machint");
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		for (Map<String, Object> map : aggList) {

			String finalsql = "UPDATE EMP_SCLAR_DEST SET SUM_AMOUNT ='" + map.get("RES") + "' WHERE BONUS ='"
					+ map.get(groupBy) + "'";

			System.out.println(finalsql);

			Statement st = con.createStatement();

			int j = st.executeUpdate(finalsql);
		}

		System.out.println("done");

	}

	public static List<Map<String, Object>> getAggRuleData(String srcTbl, String aggFunCol, String groupBy,
			String aggFuntiong) throws ClassNotFoundException, SQLException {

		List<Map<String, Object>> rules = new LinkedList<>();

		Class.forName("oracle.jdbc.driver.OracleDriver");

		Connection con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl", "hr", "Machint");
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			String sql = "select " + groupBy + ", " + aggFuntiong + "(" + aggFunCol + ") as res from " + srcTbl
					+ " group by " + groupBy;
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

	public static List<Map<String, Object>> getSrcAggRuleData(String srcTbl, String srcTblCols, String aggFunCol,
			String groupBy) throws ClassNotFoundException, SQLException {

		List<Map<String, Object>> rules = new LinkedList<>();

		Class.forName("oracle.jdbc.driver.OracleDriver");

		Connection con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl", "hr", "Machint");
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		try {

			System.out.println("Connection established......");

			Statement stmt = con.createStatement();

			// step4 execute query
			srcTblCols = srcTblCols.replace("[", "");
			srcTblCols = srcTblCols.replace("]", "");

			String sql = "select " + srcTblCols + " from " + srcTbl;
			System.out.println(sql);
			ResultSet rs_source = stmt.executeQuery(sql);

			ArrayList<String> rs_source_columns = new ArrayList<String>();
			ResultSetMetaData metadata = rs_source.getMetaData();
			int columnCount = metadata.getColumnCount();
			for (int i = 1; i <= columnCount; i++) {
				rs_source_columns.add(metadata.getColumnName(i));
			}

			while (rs_source.next()) {
				HashMap<String, Object> map = new HashMap<>();
				for (String colName : rs_source_columns) {

					map.put(colName, rs_source.getString(colName));
				}
				rules.add(map);

			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return rules;
	}

	public static int instertDestSumRuleData(String destTbl, String destTblCols, Map<String, Object> map)
			throws ClassNotFoundException, SQLException {

		System.out.println("--------------instertDestSumRuleData  start------------------");

		Class.forName("oracle.jdbc.driver.OracleDriver");

		Connection con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl", "hr", "Machint");
		System.out.println("Connection established......");

		con.prepareStatement("alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'").execute();

		String tempDestColsArray[] = destTblCols.split(",");

		String sql1 = "INSERT INTO " + destTbl + " ( " + destTblCols + ") VALUES (";

		String sql2 = "";

		for (String col : tempDestColsArray) {
			sql2 = sql2 + "?,";
		}

		StringBuilder sb = new StringBuilder(sql2);
		sb.deleteCharAt(sb.length() - 1);
		sb.append(")");
		sql2 = sb.toString();

		String finalsql = sql1 + sql2;

		System.out.println(finalsql);

		tempDestColsArray = destTblCols.split(",");
		try {

			PreparedStatement ps = con.prepareStatement(finalsql);

			int i = 1;

			for (String col : tempDestColsArray) {
				String temp = col.trim();

				ps.setObject(i, map.get(temp));

				i++;

			}
			int j = ps.executeUpdate();

		} catch (Exception e) {
			e.printStackTrace();
			return 0;
		}

		System.out.println("--------------instertDestSumRuleData  end------------------");
		return 1;
	}

}
